// ****************************************************************************
// 
// FLV Extract
// Copyright (C) 2006  Moitah (moitah@yahoo.com)
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// ****************************************************************************

using System;

namespace JDP {
	public static class ByteOrder {
		public static ulong Reverse(ulong x) {
			return
				((x >> 56) & 0x00000000000000FF) |
				((x >> 40) & 0x000000000000FF00) |
				((x >> 24) & 0x0000000000FF0000) |
				((x >>  8) & 0x00000000FF000000) |
				((x <<  8) & 0x000000FF00000000) |
				((x << 24) & 0x0000FF0000000000) |
				((x << 40) & 0x00FF000000000000) |
				((x << 56) & 0xFF00000000000000);
		}

		public static long Reverse(long x) {
			ulong ux = (ulong)x;
			return (long)(
				((ux >> 56) & 0x00000000000000FF) |
				((ux >> 40) & 0x000000000000FF00) |
				((ux >> 24) & 0x0000000000FF0000) |
				((ux >>  8) & 0x00000000FF000000) |
				((ux <<  8) & 0x000000FF00000000) |
				((ux << 24) & 0x0000FF0000000000) |
				((ux << 40) & 0x00FF000000000000) |
				((ux << 56) & 0xFF00000000000000));
		}

		public static uint Reverse(uint x) {
			return
				((x >> 24) & 0x000000FF) |
				((x >>  8) & 0x0000FF00) |
				((x <<  8) & 0x00FF0000) |
				((x << 24) & 0xFF000000);
		}

		public static int Reverse(int x) {
			uint ux = (uint)x;
			return (int)(
				((ux >> 24) & 0x000000FF) |
				((ux >>  8) & 0x0000FF00) |
				((ux <<  8) & 0x00FF0000) |
				((ux << 24) & 0xFF000000));
		}

		public static ushort Reverse(ushort x) {
			return (ushort)(
				((x >> 8) & 0x00FF) |
				((x << 8) & 0xFF00));
		}

		public static short Reverse(short x) {
			ushort ux = (ushort)x;
			return (short)(
				((ux >> 8) & 0x00FF) |
				((ux << 8) & 0xFF00));
		}
	}
}